---------------------------------------------------------------------------------------------------
--
-- Title       : serial_porca
-- Design      : serial_porca
-- Author      : Fernando
-- Company     : PUCRS
--
---------------------------------------------------------------------------------------------------
--
-- File        : usy.vhd
-- Generated   : Thu Jun  9 15:10:35 2005
-- From        : interface description file
-- By          : Itf2Vhdl ver. 1.20
--
---------------------------------------------------------------------------------------------------
--
-- Description : 
--
---------------------------------------------------------------------------------------------------

--{{ Section below this comment is automatically maintained
--   and may be overwritten
--{entity {serial_porca} architecture {serial_porca}}

library IEEE;
use IEEE.STD_LOGIC_1164.all;

entity serial_porca is
	 port(
		 clock : in STD_LOGIC;
		 reset : in STD_LOGIC;
		 send : in STD_LOGIC;
		 palavra : in STD_LOGIC_VECTOR(7 downto 0);
		 busy : out STD_LOGIC;
		 linha : out STD_LOGIC
	     );
end serial_porca;

--}} End of automatically maintained section

architecture serial_porca of serial_porca is
type states is (Init, startbit, bit7, bit6, bit5, bit4,
	bit3, bit2, bit1, bit0, stopbit);  
signal Eatual, ProxEst : states;

begin
	process	(reset, clock)
	begin
		if reset='1'  then Eatual <= Init; 
		elsif clock'event and clock='1' then
			Eatual <= ProxEst;
		end if;
	end process;

	process	(Eatual, palavra, send)
	begin
	      case Eatual is
		      when Init =>
				  if send='0' then ProxEst <= Init;
				  else ProxEst <= startbit;  
				  end if;
				  busy <='0';
				  linha <='1';
		      when startbit =>
			  	  ProxEst <= bit0;
				  busy <='1';
				  linha <='0';
		      when bit0 =>
			  	  ProxEst <= bit1;
				  linha <=palavra(0);
		      when bit1 =>
			  	  ProxEst <= bit2;
				  linha <=palavra(1);
		      when bit2 =>
			  	  ProxEst <= bit3;
				  linha <=palavra(2);
		      when bit3 =>
			  	  ProxEst <= bit4;
				  linha <=palavra(3);
		      when bit4 =>
			  	  ProxEst <= bit5;
				  linha <=palavra(4);
		      when bit5 =>
			  	  ProxEst <= bit6;
				  linha <=palavra(5);
		      when bit6 =>
			  	  ProxEst <= bit7;
				  linha <=palavra(6);
		      when bit7 =>
			  	  ProxEst <= stopbit;
				  linha <=palavra(7);
		      when stopbit =>
				  if send='0' then
					  ProxEst <= stopbit;
				  else
					  ProxEst <= startbit;
				  end if;
				  linha <='1';
				  busy <= '0';
		      when others =>
		         null;
		  end case;

	end process;
	

end serial_porca;
